百度关键词优化三天上首页!同行都是朋友, 欢迎一起互利共赢。谢绝一切非正规行业服务,感谢以下同行、团队、平台和代理的支持:

百度站长平台、MIP开发小组、SEO焦大老友、SEO每天一贴ZAC大哥、卢松松大哥、海瑶SEO兄弟、附子SEO兄弟、探索者SEO、帮站SEO好友、互点宝、超快排平台

百亿互刷宝、下拉天下、SEO自学网、SEO研究中心、小明SEO、王德春SEO、马海祥博客、踏雪无痕挂机工作室、SEO云优化好友、云客网、杭州思亿欧、网赚吧、北京SEO韩非老弟

需要了解以上同仁的相关信息,我们已经给你做好了搜索框,看右上角绿色那个,输入搜索即刻直达

网站统计: 共有读稿:14376部 / 今日更新:4篇 / 评论:17条 / 会员:60 名 / 阅读:485483
您好,请 【登陆】【注册】
文章页横幅广告
您现在的位置:SEO平台 > PHP网站建设 >

PHP异常处理浅析

2015.07.22

浏览:

【导语】如果您觉得本篇内容还不错,请点击文章下面的赞,然后分享给朋友哦!...

PHP异常处理浅析-破洛洛教学网...请看详情...

seo

seo

   这篇文章主要介绍了PHP异常处理浅析,本文着重讲解如何捕获异常,并给出代码操作实例,需要的朋友可以参考下

  PHP预定了两个异常类:Exception和ErrorException

   代码如下:

  Exception {

  /* 属性 */

  protected string $message ; //异常消息内容

  protected int $code ; //异常代码号

  protected string $file ; //抛出异常的文件名

  protected int $line ; //抛出异常在该文件中的行号

  /* 方法 */

  public __construct ([ string $message = "" [, int $code = 0 [, Exception $previous = null]]] )

  final public string getMessage ( void ) //异常抛出的信息

  final public Exception getPrevious ( void ) //前一异常

  final public int getCode ( void ) //异常代码,这是用户自定义的

  final public string getFile ( void ) //发生异常的文件路劲

  final public int getLine ( void ) //发生异常的行

  final public array getTrace ( void ) //异常追踪信息(array)

  final public string getTraceAsString ( void ) //异常追踪信息(string)

  public string __toString ( void ) //试图直接 将异常对象当作字符串使用时调用子函数的返回值

  final private void __clone ( void ) //克隆异常对象时调用

  }

   代码如下:

  ErrorException extends Exception {

  /* 属性 */

  protected int $severity ;

  /* 方法 */

  public __construct ([ string $message = "" [, int $code = 0 [, int $severity = 1 [, string $filename = __FILE__ [, int $lineno = __LINE__ [, Exception $previous = NULL ]]]]]] )

  final public int getSeverity ( void )

  /* 继承的方法 */

  final public string Exception::getMessage ( void )

  final public Exception Exception::getPrevious ( void )

  final public int Exception::getCode ( void )

  final public string Exception::getFile ( void )

  final public int Exception::getLine ( void )

  final public array Exception::getTrace ( void )

  final public string Exception::getTraceAsString ( void )

  public string Exception::__toString ( void )

  final private void Exception::__clone ( void )

  }

  那么如何捕获异常?

  (1)PHP可用try...catch...捕获异常,进行异常处理的代码必须在try代码块内。

   代码如下:

  try {

  throw new Exception('exception test 1', 1001);

  } catch(Exception $e) {

  echo $e->getMessage().'-'.$e->getCode();

  }

  (2)用户可以自定义异常处理函数[set_exception_handler],用于没用用try/catch捕获的异常。

   代码如下:

  function exception_handler ( $e ) {

  echo "Uncaught exception: " , $e -> getMessage (), "\n" ;

  }

  set_exception_handler ( 'exception_handler' );

  throw new Exception ( 'Uncaught Exception' );

  echo "这行不会执行了";

  可以看到使用ser_exception_handler回调函数处理异常,后续的代码不会继续执行,但try-catch可以。

  (3)PHP可用多catch捕获不同类型异常,并允许在catch代码块内再次抛出异常。

  代码如下:

  //请根据实际扩展异常类

  class MyException extends Exception {

  public function __construct($message = '', $code = 0) {

  }

  public function myFunction() {

  echo 'just for test';

  }

  }

  try {

  throw new MyException('an error');

  } catch (MyException $e) {

  echo $e->myFunction();

  } catch (Exception $e) {

  echo $e->getMessage();

  }

  (4)PHP5.5已经支持finally关键词,你无需关心异常是否溢出了。

PHP异常处理浅析

  可对比如下:

   代码如下:

  function doSomething() {

  $resource = createResource();

  try {

  $result = useResource($resource);

  } catch (Exception $e) {

  releaseResource($resource);

  log($e->getMessage());

  exit();

  }

  releaseResource($resource);

  return $result;

  }

  //使用finally后

  function doSomething2() {

  $resource = createResource();

  try {

  $result = useResource($resource);

  return $result;

  } catch (Exception $e) {

  log($e->getMessage());

  exit();

  } finally {

  releaseResource($resource);

  }

  }

0
赞一个
关键词:
☆喜欢这篇文章吗?分享给你的好友吧!点击这里复制网址☆
共有57人阅读,期待你的评论!评论
请先登陆后才能发表评论哦!没账号?赶紧注册一个吧!
最新评论
热门标签
回到顶部